package org.openxma.dsl.reference.validation;

import org.springframework.validation.Errors;
import org.openxma.dsl.reference.model.PrivateCustomer;
import org.openxma.dsl.reference.validation.CustomerValidator;
import org.springframework.validation.ValidationUtils;

@SuppressWarnings("boxing")
public abstract class PrivateCustomerGenValidator extends CustomerValidator {
    
    public boolean isCcInfoRequired(PrivateCustomer privateCustomer) {
        return Boolean.TRUE;
    }
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return PrivateCustomer.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(PrivateCustomer privateCustomer) {
        Errors errors = createErrors(privateCustomer);      
        super.validate(privateCustomer,errors);
        validate(privateCustomer,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        PrivateCustomer privateCustomer = (PrivateCustomer) object;
        if (isCcInfoRequired(privateCustomer)) {
            ValidationUtils.rejectIfEmpty(errors, "ccInfo", "field.required");
        }
    }
    
}
