namespace org.openxma.dsl.reference.^xma.customeredit
import org.openxma.dsl.reference.*
import org.openxma.dsl.reference.^xma.*

/**
 * Customer Edit Comop
 */
component xma::CustomerEdit {
	property String uncommentedProperty
	
    data Customer customer
    data Customer[] customers
    data OrderStateView[] orders
    data VOData vodata

	/**
	 * Customer search form
	 */
    page xma::CustomerSearchForm {
        command findCustomer 
        command selectCustomer

        eventmapping {
            onInit -> findCustomer
            findButton   -> findCustomer
            customerTable.onSelection -> selectCustomer
        }

        panel xma::customerSearchFormComp {
	        vpanel customerTableHeader bottom=100 {
	            label headerText "Customers:" left=0
	            customer.firstName
	            customer.lastName  | button findButton "Find"
	        }
	        table customerTable key=customers.oid top=customerTableHeader bottom=100% {
	            customers.firstName    width=80
	            customers.lastName     width=140
	            customers.birthDate    width=140
	            customers.emailAddress width=140
	        }
        }
    }

    page xma::CustomerEditForm {
        command readCustomer
        command saveCustomer
        command cancel
        command selectOrder

        eventmapping {
            onInit -> readCustomer
            okButton     -> saveCustomer
            cancelButton -> cancel
        }

        panel xma::customerEditFormComp {
            tabfolder tabfolder1 top=0 bottom=actionComposite {
                tabpage Page1 "Basic Information" {
                    vpanel infoComposite top=10 style=dataContainer {
                        customer.firstName
                        customer.lastName
                        customer.emailAddress
                        customer.birthDate
                        customer.telefonNumber
                    }
                }
                tabpage Page2 "Orders" {
                    eventmapping {
                        orderTable.onSelection -> selectOrder
                    }
                    vpanel orderTableHeader bottom=20 {
                        label headerText "Orders of the customer:" left=0
                    }
                    table orderTable key=orders.oid top=orderTableHeader bottom=100% {
                        orders.placementDate width=80
                        orders.orderState width=140
                    }
                }
            }
            hpanel actionComposite bottom=100% align=right style=actionButton {
                button okButton "Ok"
                button cancelButton "Cancel"
            }
        }
    }
}





